"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.callDataSource = void 0;
const load_datasources_1 = require("../load-datasources");
const weda_node_sdk_1 = require("@cloudbase/weda-node-sdk");
async function callDataSource(options) {
    const dataSources = await load_datasources_1.loadDataSources();
    const dataSource = dataSources.find(ds => options.dataSourceName === ds.name);
    if (!dataSource)
        throw new weda_node_sdk_1.TCBError(404, `datasource ${options.dataSourceName} not found or not loaded properly`);
    const result = await weda_node_sdk_1.invokeDataSource(Object.assign(Object.assign({}, options), { dataSource }));
    return result;
}
exports.callDataSource = callDataSource;
