"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GraphQLAny = void 0;
const graphql_1 = require("graphql");
// eslint-disable-next-line @typescript-eslint/naming-convention
exports.GraphQLAny = new graphql_1.GraphQLScalarType({
    name: 'Anything',
    description: 'Any value.',
    parseValue: value => value,
    parseLiteral,
    serialize: value => value,
});
function parseLiteral(ast) {
    switch (ast.kind) {
        case graphql_1.Kind.BOOLEAN:
        case graphql_1.Kind.STRING:
            return ast.value;
        case graphql_1.Kind.INT:
        case graphql_1.Kind.FLOAT:
            return Number(ast.value);
        case graphql_1.Kind.LIST:
            return ast.values.map(parseLiteral);
        case graphql_1.Kind.OBJECT:
            return ast.fields.reduce((accumulator, field) => {
                accumulator[field.name.value] = parseLiteral(field.value);
                return accumulator;
            }, {});
        case graphql_1.Kind.NULL:
            return null;
        default:
            throw new Error(`Unexpected kind in parseLiteral: ${ast.kind}`);
    }
}
